// Spell1 Phase 2 + 2 - Arc to middle - 1.5 seconds (total 4 + 2.5 seconds)

#include "colors.inc"
//#declare Draft = version;
#include "e:\pc'sjunk\pov\adventure\dungeon.inc"
#include "e:\pc'sjunk\pov\adventure\staff.inc"
#include "e:\pc'sjunk\pov\adventure\light.inc"
#include "vstr.inc"

background { colour rgb <1, 1, 1> }

// No identifier means it applies to the camera and light_source translations.
// CL designates camera look_at.
// L  designates light_source translation.
// C  designates camera translation.
// S  designates staff
#declare P1_Motion = <0, 0, 60>;
#declare P1_Rotate_S = <0, 0, 0>;
#declare P1_Motion_S = P1_Motion + <0, 0, 0>;
#declare P2_Motion_CL = <sin(pi/3), 0, cos(pi/3)> - <0, 0, 1>;
#declare P2_Motion_L = vrotate(<-1, 1, 3>, <0, 60, 0>) - <-1, 1, 3>;
#declare P2_Rotate_S = <0, 60, 0>;
#declare P2_Motion_S = vrotate(<1.5, 0, 4>, <0, 60, 0>) - <1.5, 0, 4>;

camera {
	location <0, 15, -25>
	look_at <0, 15, -24> + P2_Motion_CL
	translate P1_Motion
}

light_source {
	<-1, 16, -22>
	colour White
	fade_distance 25
	fade_power 1.5
	translate P1_Motion
	translate P2_Motion_L
}
/*	
light_source {
	<90, 17, 45>
	colour White
	fade_distance 25
	fade_power 1.5
}
*/
#declare Light_markers = union {
	// y-axis
	sphere { <-1, 16.2, -22>, 0.05
		pigment { colour rgbt <1.0, 1.0, 0.0, 0.6> }
	}
	sphere { <-1, 15.8, -22>, 0.05
		pigment { colour rgbt <1.0, 1.0, 0.0, 0.6> }
	}
	// x-axis
	sphere { <-1.2, 16, -22>, 0.05
		pigment { colour rgbt <1.0, 0.0, 1.0, 0.6> }
	}
	sphere { <-0.8, 16, -22>, 0.05
		pigment { colour rgbt <1.0, 0.0, 1.0, 0.6> }
	}
	// z-axis
	sphere { <-1, 16, -22.2>, 0.05
		pigment { colour rgbt <0.0, 1.0, 1.0, 0.6> }
	}
	sphere { <-1, 16, -21.8>, 0.05
		pigment { colour rgbt <0.0, 1.0, 1.0, 0.9> }
	}
	translate P1_Motion
	translate P2_Motion_L
}
//object { Light_markers }
object { Light_Sphere
	rotate < 68.96/2.689 + 68.96 - 68.96/1.771, 79.20/2.890 + 79.20 - 79.20/1.238, 23.04/2.478 + 23.04 - 23.04/1.485 >
	rotate < 11.48/2.580, 12.50/2.236, 10.02/2.950 > + < 11.48 - 11.48/1.358, 12.50 - 12.50/1.432, 10.02 - 10.02/1.864 >
	rotate < 25.12/2.533*pow(clock, 2.533), 38.64/2.281*pow(clock, 2.281), 29.44/2.475*pow(clock, 2.475) >
	translate <-1, 16, -22>
	translate P1_Motion
	translate P2_Motion_L
}

#declare delay_1o3_clock = (clock >= 1/3)*(clock - 1/3)*3/2;  // delayed motion by 1/3

object { Staff
	rotate P1_Rotate_S
	rotate P2_Rotate_S
	rotate y*-(20 - 20*delay_1o3_clock)
	rotate vrotate(<1.5 - 1.5*delay_1o3_clock, 0, 10 - 10*delay_1o3_clock>, <0, 60, 0>)
	translate <1.5, 0, -21>
	translate P1_Motion_S
	translate P2_Motion_S
	translate <0.5, 1, -2> - <0.5, 1, -2>*delay_1o3_clock
}

#declare Spell_1 = merge {
   sphere { <0.00, 0.00, 0.00>, 5.00 }
   #local i = 0;
   #while ( i < 350 )
      cone { <-4.00, 0.00, 0.00>, 2.00, <-12.5, 0.00, 0.00>, 0.00
         scale <1.00, 1.00, 1.50>
         rotate z*i
      }            
      #local i = i + 60;
   #end
   pigment { colour rgbt <1.00, 1.00, 1.00, 1.00> }
   hollow
   interior {
      media {
         emission 1
         intervals 20
         density {
            spherical
				turbulence 0.2
            colour_map {
               [ 0.00 colour rgb <0.00, 0.00, 0.50>*1.00 ]
               [ 0.40 colour rgb <0.00, 0.00, 1.00>*3.00 ]
               [ 1.00 colour rgb <0.50, 0.50, 1.00>*4.00 ]
            }
            scale 5.00
         }
      }
      media {
      	emission 1
      	intervals 20
         density {
            spherical
            colour_map {
               [ 0.00 colour rgb <0.00, 0.00, 0.25>*1.5 ]
               [ 0.20 colour rgb <0.00, 0.00, 1.00>*1.5 ]
               [ 0.60 colour rgb <0.25, 0.25, 1.00>*1.5 ]
               [ 1.00 colour rgb <0.00, 0.00, 0.00> ]
            }
            scale 12.50
         }
      }
   }                  
}

object { Spell_1
   scale 0.001 + 0.054 + 0.055*3*min(1/3, clock) + 0.02*sin( 2*pi*delay_1o3_clock )
   rotate z*240*1.5*clock
   translate <0, 13.8, 0>
	rotate P1_Rotate_S
	rotate P2_Rotate_S
	rotate y*-20
	rotate vrotate(<1.5, 0, 10>, <0, 60, 0>)
	translate <1.5, 0, -21>
	translate P1_Motion_S
	translate P2_Motion_S
	translate <0.5, 1, -2>
	translate <33.7478, 0, -58.4529> + <-67.5*cos(pi/3 + pi/6*clock), 0, 67.5*sin(pi/3 + pi/6*clock)>
}

light_source {
	<0, 13.8, 0>
	colour rgb <0.7, 0.7, 1.0>
	fade_distance 10 + 10*3*min(1/3, clock) + 5*sin( 2*pi*delay_1o3_clock )
	fade_power 2
	rotate P1_Rotate_S
	rotate P2_Rotate_S
	rotate y*-20
	rotate vrotate(<1.5, 0, 10>, <0, 60, 0>)
	translate <1.5, 0, -21>
	translate P1_Motion_S
	translate P2_Motion_S
	translate <0.5, 1, -2>
	translate <33.7478, 0, -58.4529> + <-67.5*cos(pi/3 + pi/6*clock), 0, 67.5*sin(pi/3 + pi/6*clock)>
}
/*
sphere { <0, 13.8, 0>, 0.1 + 0.2 + 0.3*3*min(1/3, clock) + 0.1*sin( 2*pi*delay_1o3_clock )
	pigment { colour rgbt <0.3, 0.5, 1.0, 0.7> }
	finish { ambient 0.8 }
	rotate P1_Rotate_S
	rotate P2_Rotate_S
	rotate y*-20
	rotate vrotate(<1.5, 0, 10>, <0, 60, 0>)
	translate <1.5, 0, -21>
	translate P1_Motion_S
	translate P2_Motion_S
	translate <0.5, 1, -2>
	translate <33.7478, 0, -58.4529> + <-67.5*cos(pi/3 + pi/6*clock), 0, 67.5*sin(pi/3 + pi/6*clock)>
}
*/

#declare gem = <0, 13.8, 0>;
#declare gem = vrotate(gem, P1_Rotate_S);
#declare gem = vrotate(gem, P2_Rotate_S);
#declare gem = vrotate(gem, y*-20*clock);
#declare gem = vrotate(gem, vrotate(<1.5*clock, 0, 10*clock>, <0, 60, 0>));
#declare gem = gem + <1.5, 0, -21> + P1_Motion_S + P2_Motion_S + <0.5, 1, -2>*clock;
#debug vstr( gem, 0, 10 )

object { Dungeon }